#ifndef MIXSNET_HOMOGAUSSIANDISTRIBUTION_H
#define MIXSNET_HOMOGAUSSIANDISTRIBUTION_H

namespace mixsnet{

  class HomoscedasticGaussian : public HeteroscedasticGaussian
  {
  protected:
    double _sigma2;
    virtual void normalizeSigma2ql();
  public:
    HomoscedasticGaussian(color_type nbcol)
    : HeteroscedasticGaussian(nbcol), _sigma2(0.) {};
    HomoscedasticGaussian(const HomoscedasticGaussian& dist)
    : HeteroscedasticGaussian(dist), _sigma2(dist._sigma2) {}
    virtual ~HomoscedasticGaussian(){};
    void reinit(unsigned int nbcol) {*this = HomoscedasticGaussian(nbcol);}
    virtual double getSigma2ql(color_type q, color_type l) const{
      return _sigma2;
    }
    virtual void setSigma2ql(color_type q, color_type l, double sigma2) {
      _sigma2 = sigma2;}
  };

  void HomoscedasticGaussian::normalizeSigma2ql(){
    _sigma2 = 0.;
    unsigned int norm = 0;
    //std::cerr<<"_Sigma2ql before "<<this->_Sigma2ql<<std::endl;
    for (color_type q = 0; q<this->_nbcol; q++)
      for (color_type l = 0; l<=q; l++){
        _sigma2 += this->_Sigma2ql(q,l);
        norm += this->_Nql(q,l);
      }
    _sigma2 /= double(norm);
    //std::cerr<<"sigma2....."<<_sigma2<<std::endl;
    for (color_type q = 0; q<this->_nbcol; q++)
          for (color_type l = 0; l<=q; l++)
            HeteroscedasticGaussian::setSigma2ql(q,l,_sigma2);
  }

}
#endif
