#include<GaussianDistribution.hpp>
#include<iostream>
#include<math.h>
#include<assert.h>
using namespace std;
using namespace placeholders;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<int> net(argv[1]);
  Matrix<double> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());
  std::cerr<<mat<<std::endl;

  HomoscedasticGaussian dist(2);

  dist.compute(net, mat);
  assert(abs(dist.getMuql(0,0)-0.45)<0.000001);
  assert(abs(dist.getSigma2ql(0,0)-0.0191667)<0.000001);

  vector<double> v;
  for (unsigned int i=0; i<10000; i++)
    v.push_back(dist.draw(0,0,0,0));
  double mean = 0.;
  for (unsigned int i=0; i<10000; i++)
    mean+=v[i];
  mean /= 10000;
  assert(abs(dist.getMuql(0,0)-mean)<0.01);
  double var = 0.;
  for (unsigned int i=0; i<10000; i++)
    var+= (v[i]-mean)*(v[i]-mean);
  var /= 10000;
  assert(abs(dist.getSigma2ql(0,0)-var)<0.001);
  return 0;
}
